/**
 * Copyright (C) 2003-2004-2005 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

package sync4j.syncclient.demo;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.ScrollPane;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import java.util.Vector;

import sync4j.foundation.pdi.event.Calendar;
import sync4j.foundation.pdi.common.*;

/**
 * A form containing all the fields concerning a calendar.
 * This form will be a subpanel for CalendarModify and CalendarNew
 *
 * @author Fabio Maggi       @ Funambol
 * @author Marco Magistrali  @ Funambol
 */
public class CalendarForm extends Panel
implements
ActionListener,
MouseListener,
ConfigurationParameters {
    //---------------------------------------------------------- Constants

    //
    // Note this is NOT the actual size of the
    // TextField. It's just a way to avoid
    // horizontal scrolling
    //
    public static final int TF_COLUMNS = 10;

    //---------------------------------------------------------- Private data

    //
    // The window containing this panel
    //
    private MainWindow  mw                 = null           ;

    //
    // The currently displayed tab (general,personal,business)
    //
    private String      currentTab         = null           ;

    private TextField   tf1                = null           ;
    private TextField   tf2                = null           ;
    private TextField   tf3                = null           ;
    private TextField   tf4                = null           ;
    private TextField   tf5                = null           ;
    private TextField   tf6                = null           ;
    private TextField   tf7                = null           ;

    private CardLayout  cardLayout         = null           ;
    private Panel       fieldPanel         = null           ;
    private ScrollPane  scrollGeneralPane  = null           ;

    private Language    ln                 = new Language() ;

    //---------------------------------------------------------- Public methods

    public String getStartDate ()  {
        return tf2.getText();
    }
    public String getStartTime ()  {
        return tf6.getText();
    }

    public String getEndDate   ()  {
        return tf3.getText();
    }
    public String getEndTime   ()  {
        return tf7.getText();
    }

    /**
     * Creates the form subpanel.
     *
     * @param mw the window containing this panel
     */
    public CalendarForm(MainWindow mw) {

        Panel           generalPanel = null ;

        Label           lb1          = null ;
        Label           lb2          = null ;
        Label           lb3          = null ;
        Label           lb4          = null ;
        Label           lb5          = null ;
        Label           lb6          = null ;
        Label           lb7          = null ;

        this.mw = mw;

        tf1  = new TextField (TF_COLUMNS) ;
        tf2  = new TextField (TF_COLUMNS) ;
        tf3  = new TextField (TF_COLUMNS) ;
        tf4  = new TextField (TF_COLUMNS) ;
        tf5  = new TextField (TF_COLUMNS) ;
        tf6  = new TextField (TF_COLUMNS) ;
        tf7  = new TextField (TF_COLUMNS) ;

        tf1.addMouseListener (this ) ;
        tf2.addMouseListener (this ) ;
        tf3.addMouseListener (this ) ;
        tf4.addMouseListener (this ) ;
        tf5.addMouseListener (this ) ;
        tf6.addMouseListener (this ) ;
        tf7.addMouseListener (this ) ;

        //
        // Subject
        //
        lb1  = new Label (ln.getString ("summary"    ) ) ;
        lb2  = new Label (ln.getString ("start_date" ) ) ;
        lb3  = new Label (ln.getString ("end_date"   ) ) ;
        lb4  = new Label (ln.getString ("location"   ) ) ;

        //
        // body
        //
        lb5  = new Label (ln.getString ("description" ) ) ;
        lb6  = new Label (ln.getString ("start_time"  ) ) ;
        lb7  = new Label (ln.getString ("end_time"    ) ) ;

        generalPanel = new Panel();

        generalPanel.setLayout(new GridLayout(11, 2));

        generalPanel.add (lb1         ) ;
        generalPanel.add (tf1         ) ;
        generalPanel.add (lb2         ) ;
        generalPanel.add (tf2         ) ;
        generalPanel.add (lb6         ) ;
        generalPanel.add (tf6         ) ;
        generalPanel.add (lb3         ) ;
        generalPanel.add (tf3         ) ;
        generalPanel.add (lb7         ) ;
        generalPanel.add (tf7         ) ;
        generalPanel.add (lb4         ) ;
        generalPanel.add (tf4         ) ;
        generalPanel.add (lb5         ) ;
        generalPanel.add (tf5         ) ;
        generalPanel.add (new Label() ) ;
        generalPanel.add (new Label() ) ;
        generalPanel.add (new Label() ) ;
        generalPanel.add (new Label() ) ;
        generalPanel.add (new Label() ) ;
        generalPanel.add (new Label() ) ;

        scrollGeneralPane = new ScrollPane (ScrollPane.SCROLLBARS_AS_NEEDED ) ;
        scrollGeneralPane.add              (generalPanel                    ) ;

        fieldPanel = new Panel();
        fieldPanel.setSize(100,100);
        cardLayout = new CardLayout();
        fieldPanel.setLayout (cardLayout                  ) ;
        fieldPanel.add       (scrollGeneralPane,"general" ) ;

        //
        // Default
        //
        cardLayout.show(fieldPanel, "general" );

        setLayout(new BorderLayout());
        add(fieldPanel,BorderLayout.CENTER);
    }

    public void actionPerformed(ActionEvent evt) {
        if (evt.getActionCommand().equals("OK")) {

        }
    }

    /**
     * Invoked when the mouse button has been clicked (pressed and released)
     * on a component.
     * This method adjusts the scrollpanes so that the selected
     * textfield is placed on top of the pane.
     *
     * @param evt the occurred event
     */
    public void mouseClicked(MouseEvent evt) {

    }

    /**
     * Invoked when a mouse button has been pressed on a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mousePressed(MouseEvent evt) {
        // do nothing
    }

    /**
     * Invoked when a mouse button has been released on a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mouseReleased(MouseEvent evt) {
        // do nothing
    }

    /**
     * Invoked when the mouse enters a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mouseEntered(MouseEvent evt) {
        // do nothing
    }

    /**
     * Invoked when the mouse exits a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mouseExited(MouseEvent evt) {
        // do nothing
    }
    //---------------------------------------------------------- Protected methods

    /**
     * Sets the fields with the values contained
     * in the specified Calendar object.
     * Used to display the old value of calendar
     *
     * @param calendar the Calendar object which is the source of the values
     */
    protected void setFields(Calendar calendar) {

        String dateStart = null ;
        String dateEnd   = null ;
        String timeStart = null ;
        String timeEnd   = null ;

        dateStart = (String) calendar.
                        getEvent().getDtStart ().getPropertyValue() ;
        dateEnd   = (String) calendar.
                        getEvent().getDtEnd   ().getPropertyValue() ;


        dateStart = FieldsHelper.convertDateFromUTC(dateStart);

        if (dateStart != null && dateStart.length() > 10) {
            timeStart = dateStart.substring(11,16);
            dateStart = dateStart.substring(0,10);
        }

        dateEnd = FieldsHelper.convertDateFromUTC(dateEnd);

        if (dateEnd != null &&   dateEnd.length() > 10)   {
            timeEnd = dateEnd.substring(11,16);
            dateEnd = dateEnd.substring(0,10);
        }

        // General
        tf1.setText((String)calendar.
            getEvent().getSummary     ().getPropertyValue()) ;
        tf2.setText(dateStart ) ;
        tf3.setText(dateEnd   ) ;
        tf4.setText((String)calendar.
            getEvent().getLocation    ().getPropertyValue()) ;
        tf5.setText((String)calendar.
            getEvent().getDescription ().getPropertyValue()) ;
        tf6.setText(timeStart != null ? timeStart : "") ;
        tf7.setText(timeEnd   != null ? timeEnd   : "") ;

    }

    /**
     * Returns a new Calendar object containing the informations set in the textfields.
     * This method also builds the LABELs from the provided addresses, when at least
     * street, city, state, postal code and country are specified.
     *
     * @return the Calendar object containing the informations set in the textfields
     */
    protected Calendar getFields(){

        Calendar  calendar  = null ;

        String    startDate = null ;
        String    endDate   = null ;

        String fullStartDate = null;
        String fullEndDate   = null;

        fullStartDate = tf2.getText() + " " + tf6.getText() + ":00";
        fullEndDate   = tf3.getText() + " " + tf7.getText() + ":00";

        calendar = new Calendar();

        startDate = FieldsHelper.convertDateToUTC(fullStartDate) ;
        endDate   = FieldsHelper.convertDateToUTC(fullEndDate) ;

        calendar.getEvent().
            getSummary     ().setPropertyValue(tf1.getText()) ;
        calendar.getEvent().
            getDtStart     ().setPropertyValue(startDate    ) ;
        calendar.getEvent().
            getDtEnd       ().setPropertyValue(endDate      ) ;
        calendar.getEvent().
            getLocation    ().setPropertyValue(tf4.getText()) ;
        calendar.getEvent().
            getDescription ().setPropertyValue(tf5.getText()) ;

        return calendar;
    }

    /**
     * Sets all the textfields to an empty string.
     */
    protected void blankFields() {

        tf1.setText ("" ) ;
        tf2.setText ("" ) ;
        tf3.setText ("" ) ;
        tf4.setText ("" ) ;
        tf5.setText ("" ) ;
        tf6.setText ("" ) ;
        tf7.setText ("" ) ;

    }

}